/// YApi QuickType插件生成，具体参考文档:https://plugins.jetbrains.com/plugin/18847-yapi-quicktype/documentation

import 'dart:convert';

RewardsListState rewardsListStateFromJson(String str) => RewardsListState.fromJson(json.decode(str));

String rewardsListStateToJson(RewardsListState data) => json.encode(data.toJson());

class RewardsListState {
  //类型选项
  final List<String> optionList = ["条件1", "条件2", "条件3", "条件4"];
  String? selectedOption;
  RewardsListState({
    required this.curPage,
    required this.pageSize,
    required this.list,
    required this.filterCount,
    this.selectedOption,
  });

  int curPage;
  int pageSize;
  List<Map<String, dynamic>> list;
  int filterCount;

  factory RewardsListState.fromJson(Map<dynamic, dynamic> json) => RewardsListState(
    curPage: json["curPage"],
    pageSize: json["pageSize"],
    list: List<Map<String, dynamic>>.from(json["list"].map((x) => x)),
    filterCount: json["filterCount"],
  );

  Map<dynamic, dynamic> toJson() => {
    "curPage": curPage,
    "pageSize": pageSize,
    "list": List<dynamic>.from(list.map((x) => x)),
    "filterCount": filterCount,
  };

  RewardsListState copyWith({
    int? curPage,
    int? pageSize,
    List<Map<String, dynamic>>? list,
    int? filterCount,
    String? selectedOption,
  }) {
    return RewardsListState(
      curPage: curPage ?? this.curPage,
      pageSize: pageSize ?? this.pageSize,
      list: list ?? this.list,
      filterCount: filterCount ?? this.filterCount,
      selectedOption: selectedOption ?? this.selectedOption,
    );
  }
}
