import 'package:domain/entity/form_content_entity.dart';
import 'package:domain/generated/json/base/json_field.dart';
import 'package:domain/generated/json/form_detail_entity.g.dart';
import 'dart:convert';
export 'package:domain/generated/json/form_detail_entity.g.dart';

@JsonSerializable()
class FormDetailEntity {
	String? id;
	@JSONField(name: "user_id")
	String? userId;
	FormContentEntity? content;  //详情内容
	int status = 0;  //0-已提交未审核，1-已审核通过，2-审核失败
	@JSONField(name: "sent_on")
	String? sentOn;
	@JSONField(name: "rejected_on")
	String? rejectedOn;
	@JSONField(name: "approved_on")
	String? approvedOn;

	FormDetailEntity();

	factory FormDetailEntity.fromJson(Map<String, dynamic> json) => $FormDetailEntityFromJson(json);

	Map<String, dynamic> toJson() => $FormDetailEntityToJson(this);

	@override
	String toString() {
		return jsonEncode(this);
	}
}
