import 'package:domain/generated/json/base/json_field.dart';
import 'package:domain/generated/json/garage_sale_rent_entity.g.dart';
import 'dart:convert';
export 'package:domain/generated/json/garage_sale_rent_entity.g.dart';

@JsonSerializable()
class GarageSaleRentEntity {
	double? id;
	String? title;
	double? price;
	List<String>? resources;
	@JSONField(name: "created_at")
	String? createdAt;
	bool? liked;
	@JSONField(name: "likes_count")
	double? likesCount;
	GarageSaleRentAccount? account;

	GarageSaleRentEntity();

	factory GarageSaleRentEntity.fromJson(Map<String, dynamic> json) => $GarageSaleRentEntityFromJson(json);

	Map<String, dynamic> toJson() => $GarageSaleRentEntityToJson(this);

	@override
	String toString() {
		return jsonEncode(this);
	}
}

@JsonSerializable()
class GarageSaleRentAccount {
	double? id;
	String? name;
	String? avatar;

	GarageSaleRentAccount();

	factory GarageSaleRentAccount.fromJson(Map<String, dynamic> json) => $GarageSaleRentAccountFromJson(json);

	Map<String, dynamic> toJson() => $GarageSaleRentAccountToJson(this);

	@override
	String toString() {
		return jsonEncode(this);
	}
}