import 'package:domain/generated/json/base/json_convert_content.dart';
import 'package:domain/entity/garage_sale_rent_entity.dart';

GarageSaleRentEntity $GarageSaleRentEntityFromJson(Map<String, dynamic> json) {
  final GarageSaleRentEntity garageSaleRentEntity = GarageSaleRentEntity();
  final double? id = jsonConvert.convert<double>(json['id']);
  if (id != null) {
    garageSaleRentEntity.id = id;
  }
  final String? title = jsonConvert.convert<String>(json['title']);
  if (title != null) {
    garageSaleRentEntity.title = title;
  }
  final double? price = jsonConvert.convert<double>(json['price']);
  if (price != null) {
    garageSaleRentEntity.price = price;
  }
  final List<String>? resources = (json['resources'] as List<dynamic>?)?.map(
          (e) => jsonConvert.convert<String>(e) as String).toList();
  if (resources != null) {
    garageSaleRentEntity.resources = resources;
  }
  final String? createdAt = jsonConvert.convert<String>(json['created_at']);
  if (createdAt != null) {
    garageSaleRentEntity.createdAt = createdAt;
  }
  final bool? liked = jsonConvert.convert<bool>(json['liked']);
  if (liked != null) {
    garageSaleRentEntity.liked = liked;
  }
  final double? likesCount = jsonConvert.convert<double>(json['likes_count']);
  if (likesCount != null) {
    garageSaleRentEntity.likesCount = likesCount;
  }
  final GarageSaleRentAccount? account = jsonConvert.convert<GarageSaleRentAccount>(json['account']);
  if (account != null) {
    garageSaleRentEntity.account = account;
  }
  return garageSaleRentEntity;
}

Map<String, dynamic> $GarageSaleRentEntityToJson(GarageSaleRentEntity entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['title'] = entity.title;
  data['price'] = entity.price;
  data['resources'] = entity.resources;
  data['created_at'] = entity.createdAt;
  data['liked'] = entity.liked;
  data['likes_count'] = entity.likesCount;
  data['account'] = entity.account?.toJson();
  return data;
}

extension GarageSaleRentEntityExtension on GarageSaleRentEntity {
  GarageSaleRentEntity copyWith({
    double? id,
    String? title,
    double? price,
    List<String>? resources,
    String? createdAt,
    bool? liked,
    double? likesCount,
    GarageSaleRentAccount? account,
  }) {
    return GarageSaleRentEntity()
      ..id = id ?? this.id
      ..title = title ?? this.title
      ..price = price ?? this.price
      ..resources = resources ?? this.resources
      ..createdAt = createdAt ?? this.createdAt
      ..liked = liked ?? this.liked
      ..likesCount = likesCount ?? this.likesCount
      ..account = account ?? this.account;
  }
}

GarageSaleRentAccount $GarageSaleRentAccountFromJson(Map<String, dynamic> json) {
  final GarageSaleRentAccount garageSaleRentAccount = GarageSaleRentAccount();
  final double? id = jsonConvert.convert<double>(json['id']);
  if (id != null) {
    garageSaleRentAccount.id = id;
  }
  final String? name = jsonConvert.convert<String>(json['name']);
  if (name != null) {
    garageSaleRentAccount.name = name;
  }
  final String? avatar = jsonConvert.convert<String>(json['avatar']);
  if (avatar != null) {
    garageSaleRentAccount.avatar = avatar;
  }
  return garageSaleRentAccount;
}

Map<String, dynamic> $GarageSaleRentAccountToJson(GarageSaleRentAccount entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['name'] = entity.name;
  data['avatar'] = entity.avatar;
  return data;
}

extension GarageSaleRentAccountExtension on GarageSaleRentAccount {
  GarageSaleRentAccount copyWith({
    double? id,
    String? name,
    String? avatar,
  }) {
    return GarageSaleRentAccount()
      ..id = id ?? this.id
      ..name = name ?? this.name
      ..avatar = avatar ?? this.avatar;
  }
}